<?php

include_once('Database.php');
include_once('Config.php');
include_once('Global.php');
include_once('Run.php');
include_once('PrefixMultiplier.php');

session_start();

class Application
{
  var $NoFullPage = false;

  function Link($URL)
  {
    return($this->Config['BaseURL'].$URL);
  }

  function Run()
  {

  }
}

class MyApplication extends Application
{
  var $Database;
  var $Config;

  function __construct()
  {
  }

  function ShowMenu()
  {
    $Output = '<div>'.
      //'<a href="'.$this->Link('/tance/').'">Tance</a> '.
      //'<a href="'.$this->Link('/skoly/').'">Školy</a> '.
      //'<a href="'.$this->Link('/seznamka/').'">Seznamka</a> '.
      '</div>';
    return($Output);
  }

  function ProcessURL()
  {
    if(array_key_exists('REDIRECT_QUERY_STRING', $_SERVER))
      $PathString = $_SERVER['REDIRECT_QUERY_STRING'];
    else $PathString = '';
    if(substr($PathString, -1, 1) == '/') $PathString = substr($PathString, 0, -1);
    $PathItems = explode('/', $PathString);
    if(array_key_exists('REQUEST_URI', $_SERVER) and (strpos($_SERVER['REQUEST_URI'], '?') !== false))
      $_SERVER['QUERY_STRING'] = substr($_SERVER['REQUEST_URI'], strpos($_SERVER['REQUEST_URI'], '?') + 1);
    else $_SERVER['QUERY_STRING'] = '';
    parse_str($_SERVER['QUERY_STRING'], $_GET);
    return($PathItems);
  }

  // Query: text from name
  // Page: index of page, one page is 30 items
  // Category: '', all, men, women, kids, families, teams
  // TeamId: id of team
  // Count: number of items per page, default 30
  function QueryRunners($Category, $Page = 0, $TeamId = null, $Query = null, $StartNumber = null, $Count = null)
  {
    $URL = 'http://leaderboard.teribear.cz/Home/GetRunners?category='.$Category;
    if ($Page != 0) $URL .= '&page='.$Page;
    if ($TeamId != null) $URL .= '&teamId='.$TeamId;
    if ($Count != null) $URL .= '&count='.$Count;
    if ($Query != null) $URL .= '&query='.$Query;
    if ($StartNumber != null) $URL .= '&startNumber='.$StartNumber;
    $Content = file_get_contents($URL);
    $JSON = json_decode($Content, true);
    //print_r($JSON);
    return $JSON;
  }

  function ShowEmpty()
  {
    $this->Database->query('DELETE FROM RunnerStat');
    $this->Database->query('DELETE FROM Runner');
    $this->Database->query('DELETE FROM TeamStat');
    $this->Database->query('DELETE FROM Team');
  }

  function ShowSync()  
  {
    $ItemsPerPage = 30;
    $MaxCount = 450 * 30;

    // Load all runners
    $DbResult = $this->Database->query('SELECT MAX(Id) AS Id FROM Runner');
    $DbRow = $DbResult->fetch_assoc();
    $NextRunnerId = $DbRow['Id'] + 1;

    $Runners = array();
    $DbResult = $this->Database->query('SELECT Runner.Id, Runner.ChipNumber, '.
      '(SELECT RunnerStat.Distance FROM RunnerStat WHERE (RunnerStat.Runner = Runner.Id) ORDER BY RunnerStat.Distance DESC LIMIT 1) AS Distance FROM Runner');
    while ($DbRow = $DbResult->fetch_assoc())
    {
      $Runners[$DbRow['ChipNumber']] = $DbRow;
    }

    // Load all teams
    $DbResult = $this->Database->query('SELECT MAX(Id) AS Id FROM Team');
    $DbRow = $DbResult->fetch_assoc();
    $NextTeamId = $DbRow['Id'] + 1;

    $Teams = array();
    $DbResult = $this->Database->query('SELECT Team.Id, Team.WebId, '.
      '(SELECT TeamStat.Distance FROM TeamStat WHERE (TeamStat.Team = Team.Id) ORDER BY TeamStat.Distance DESC LIMIT 1) AS Distance FROM Team');
    while ($DbRow = $DbResult->fetch_assoc())
    {
      $Teams[$DbRow['WebId']] = $DbRow;
    }

    $Time = time();
    for ($i = 0; $i < 2; $i++)
    {
    $Queries = array();
    $Page = $i * $MaxCount / $ItemsPerPage;
    echo($Page.' ');
    $Response = $this->QueryRunners('all', $Page, null, null, null, $MaxCount);
    foreach ($Response['items'] as $Item)
    {
      if (($Item['Type'] == 'child') or ($Item['Type'] == 'woman') or ($Item['Type'] == 'man'))
      {
        if (!array_key_exists($Item['ChipNumber'], $Runners))
        {
          if ($Item['TeamId'] == null) 
          {
            $TeamId = null;
          } else
          {
          if (!array_key_exists($Item['TeamId'], $Teams))
          {
            $TeamId = $NextTeamId;            
            $Queries[] = $this->Database->GetInsert('Team', array(
              'Id' => $TeamId,
              'Name' => '',
              'WebId' => $Item['TeamId'],
            ));
            $Teams[$Item['TeamId']] = array('Id' => $TeamId, 'Distance' => -1);
            $NextTeamId++;
          } else 
            $TeamId = $Teams[$Item['TeamId']]['Id'];
          }

          $Gender = 0;
          if ($Item['Type'] == 'man') $Gender = 1;
          if ($Item['Type'] == 'woman') $Gender = 2;
          if ($Item['Type'] == 'child') $Gender = 3;
          $RunnerId = $NextRunnerId;
          $Queries[] = $this->Database->GetInsert('Runner', array(
            'Id' => $RunnerId,
            'Name' => $Item['Name'],
            'Gender' => $Gender,
            'Team' => $TeamId,
            'ChipNumber' => $Item['ChipNumber'],
          ));
          $Runners[$Item['ChipNumber']] = array('Id' => $RunnerId, 'Distance' => -1);
          $NextRunnerId++;
        } else 
          $RunnerId = $Runners[$Item['ChipNumber']]['Id'];

        if ($Runners[$Item['ChipNumber']]['Distance'] < $Item['OverallDistance'])
        $Queries[] = $this->Database->GetInsert('RunnerStat', array(
          'Time' => TimeToMysqlDateTime($Time),
          'Runner' => $RunnerId,
          'Distance' => $Item['OverallDistance'],
          'Rank' => $Item['Pos'],
          'Money' => $Item['Money'],
        ));
      } else
      if ($Item['Type'] == 'team')
      {
        if (!array_key_exists($Item['GroupId'], $Teams))
        {
          $Queries[] = $this->Database->GetInsert('Team', array(
            'Id' => $NextTeamId,
            'Name' => $Item['Name'],
            'WebId' => $Item['GroupId'],
          ));
          $TeamId = $NextTeamId;            
          $Teams[$Item['GroupId']] = array('Id' => $NextTeamId, 'Distance' => -1);
          $NextTeamId++;
        } else 
          $TeamId = $Teams[$Item['GroupId']]['Id'];

        if ($Teams[$Item['GroupId']]['Distance'] < $Item['OverallDistance'])
        $Queries[] = $this->Database->GetInsert('TeamStat', array(
          'Time' => TimeToMysqlDateTime($Time),
          'Team' => $TeamId,
          'Distance' => $Item['OverallDistance'],
          'Rank' => $Item['Pos'],
          'Money' => $Item['Money'],
        ));
      }
    }    
    print_r($Queries);
    $this->Database->Transaction($Queries);
    }
  }

  function ShowTeams()
  {
    $Output = '';

    $DbResult = $this->Database->query('SELECT * FROM Team');
    $DbRow = $DbResult->fetch_assoc();
    $Output .= '<h4 style="text-align: center;">Teams</h4>';

    $Where = '1';

    $DbResult = $this->Database->query('SELECT COUNT(*) FROM `Team` WHERE '.$Where);
    $DbRow = $DbResult->fetch_row();
    $PageList = GetPageList($DbRow[0]);

    $Output .= '<div id="list_content">';
    $Output .= $PageList['Output'];
    $TableColumns = array(
      array('Name' => 'Name', 'Title' => 'Name'),
      array('Name' => 'RunnersCount', 'Title' => 'Runners'),
      array('Name' => 'Distance', 'Title' => 'Distance'),
      array('Name' => 'Money', 'Title' => 'Money'),
      array('Name' => 'Rank', 'Title' => 'Rank'),
    );
    $Order = GetOrderTableHeader($TableColumns, 'Distance', 1);
    $Output .= '<table class="WideTable">';
    $Output .= $Order['Output'];
    $DbResult = $this->Database->select('Team', '*, '.
      '(SELECT COUNT(*) FROM Runner WHERE Runner.Team=Team.Id) AS RunnersCount, '.
      '0 AS Distance, '.
      '0 AS Money, '.
      '0 AS Rank',
      //'(SELECT SUM(Distance) FROM Runner WHERE Runner.Team=Team.Id) AS Distance, '.
      //'(SELECT SUM(Money) FROM Runner WHERE Runner.Team=Team.Id) AS Money ',
      $Where.$Order['SQL'].$PageList['SQLLimit']);
    while($Item = $DbResult->fetch_assoc())
    {
      if ($Item['Name'] == '') $Item['Name'] = 'Without team';
      $Output .= '<tr>'.
        '<td><a href="'.$this->Link('/team/'.$Item['Id'].'/').'">'.$Item['Name'].'</a></td>'.
        '<td>'.$Item['RunnersCount'].'</td>'.
        '<td>'.$Item['Distance'].'</td>'.
        '<td>'.$Item['Money'].'</td>'.
        '<td>'.$Item['Rank'].'</td>'.
        '</tr>';
    }
    $Output .= '</table>';
    $Output .= $PageList['Output'];
    $Output .= '</div>';

    return($Output);
  }

  function ShowTeam()
  {
    $Output = '';

    $TeamId = 1;
    if ((count($this->PathItems) > 0) and ($this->PathItems[count($this->PathItems) - 1] != ''))
      $TeamId = $this->PathItems[count($this->PathItems) - 1];
    if (!is_numeric($TeamId)) die('TeamId needs to be numeric');

    $DbResult = $this->Database->query('SELECT * FROM Team WHERE Id='.$TeamId);
    $DbRow = $DbResult->fetch_assoc();
    $Output .= '<h4 style="text-align: center;">Team '.$DbRow['Name'].'</h4>';


    $Where = 'Team='.$TeamId;

    $DbResult = $this->Database->query('SELECT COUNT(*) FROM `Runner` WHERE '.$Where);
    $DbRow = $DbResult->fetch_row();
    $PageList = GetPageList($DbRow[0]);

    $Gender = array('', 'Male', 'Female', 'Child');
    $Output .= '<div id="list_content">';
    $Output .= $PageList['Output'];
    $TableColumns = array(
      array('Name' => 'Name', 'Title' => 'Name'),
      array('Name' => 'Gender', 'Title' => 'Gender'),
      array('Name' => 'Distance', 'Title' => 'Distance'),
      array('Name' => 'Money', 'Title' => 'Money'),
      array('Name' => 'Rank', 'Title' => 'Rank'),
      array('Name' => 'Time', 'Title' => 'Last change'),
    );
    $Order = GetOrderTableHeader($TableColumns, 'Distance', 1);
    $Output .= '<table class="WideTable">';
    $Output .= $Order['Output'];
    $DbResult = $this->Database->select('Runner', '*, '.
      '(SELECT RunnerStat.Distance FROM RunnerStat WHERE RunnerStat.Runner=Runner.Id ORDER BY Time DESC LIMIT 1) AS Distance'.
      ', (SELECT RunnerStat.Money FROM RunnerStat WHERE RunnerStat.Runner=Runner.Id ORDER BY Time DESC LIMIT 1) AS Money'.
      ', (SELECT RunnerStat.Time FROM RunnerStat WHERE RunnerStat.Runner=Runner.Id ORDER BY Time DESC LIMIT 1) AS Time'.
      ', (SELECT RunnerStat.Rank FROM RunnerStat WHERE RunnerStat.Runner=Runner.Id ORDER BY Time DESC LIMIT 1) AS Rank',
      $Where.$Order['SQL'].$PageList['SQLLimit']);
    while($MeetItem = $DbResult->fetch_assoc())
    {
      $Output .= '<tr>'.
        '<td><a href="'.$this->Link('/runner/'.$MeetItem['Id'].'/').'">'.$MeetItem['Name'].'</a></td>'.
        '<td>'.$Gender[$MeetItem['Gender']].'</td>'.
        '<td>'.$MeetItem['Distance'].'</td>'.
        '<td>'.$MeetItem['Money'].'</td>'.
        '<td>'.$MeetItem['Rank'].'</td>'.
        '<td>'.HumanDateTime(MysqlDateTimeToTime($MeetItem['Time'])).'</td>'.
        '</tr>';
    }
    $Output .= '</table>';
    $Output .= $PageList['Output'];
    $Output .= '</div>';

    return($Output);
  }

  function ShowRunner()
  {
    $PrefixMultiplier = new PrefixMultiplier();
    $Output = '';

    $RunnerId = 1;
    if ((count($this->PathItems) > 0) and ($this->PathItems[count($this->PathItems) - 1] != ''))
      $RunnerId = $this->PathItems[count($this->PathItems) - 1];
    if (!is_numeric($RunnerId)) die('Runner id needs to be numeric');

    $DbResult = $this->Database->query('SELECT * FROM Runner WHERE Id='.$RunnerId);
    $DbRow = $DbResult->fetch_assoc();
    $Output .= '<div style="text-align: center;">Runner '.$DbRow['Name'].'</div>';


    $Where = 'RunnerStat.Runner='.$RunnerId;

    // Show detailed stats
    $Output .= '<div style="text-align: center">Detailed</div>';
    $DbResult = $this->Database->query('SELECT COUNT(*) FROM `RunnerStat` WHERE '.$Where);
    $DbRow = $DbResult->fetch_row();
    $PageList = GetPageList($DbRow[0]);

    $Output .= '<div id="list_content">';
    $Output .= $PageList['Output'];
    $TableColumns = array(
      array('Name' => 'Time', 'Title' => 'Time'),
      array('Name' => 'Distance', 'Title' => 'Distance [km]'),
      array('Name' => 'Money', 'Title' => 'Money [Kč]'),
      array('Name' => 'Rank', 'Title' => 'Rank'),
      array('Name' => 'Duration', 'Title' => 'Duration'),
      array('Name' => 'Length', 'Title' => 'Length [km]'),
      array('Name' => 'Speed', 'Title' => 'Speed [km/hour]'),
    );
    $Order = GetOrderTableHeader($TableColumns, 'Time', 1);
    $Output .= '<table class="WideTable">';
    $Output .= $Order['Output'];
    $DbResult = $this->Database->query('SELECT *'.
      ', (SELECT TIME_TO_SEC(TIMEDIFF(RunnerStat.Time, B.Time)) FROM RunnerStat AS B WHERE (B.Time < RunnerStat.Time) AND (B.Runner = RunnerStat.Runner) ORDER BY B.Time DESC LIMIT 1) AS Duration'.
      ', (SELECT RunnerStat.Distance - B.Distance FROM RunnerStat AS B WHERE (B.Time < RunnerStat.Time) AND (B.Runner = RunnerStat.Runner) ORDER BY B.Time DESC LIMIT 1) AS Length'.
      ', NULL AS Speed'.
      ' FROM RunnerStat'.
      ' WHERE '.$Where.$Order['SQL'].$PageList['SQLLimit']);
    while($MeetItem = $DbResult->fetch_assoc())
    {
      $Output .= '<tr>'.
        '<td>'.HumanDateTime(MysqlDateTimeToTime($MeetItem['Time'])).'</td>'.
        '<td>'.$MeetItem['Distance'].'</td>'.
        '<td>'.$MeetItem['Money'].'</td>'.
        '<td>'.$MeetItem['Rank'].'</td>';
      if ($MeetItem['Duration'] != null) $Output .= '<td>'.$PrefixMultiplier->Add($MeetItem['Duration'], '', 4, 'Time').'</td>';
        else $Output .= '<td>&nbsp;</td>';
      $Output .= '<td>'.$MeetItem['Length'].'</td>';
      if ($MeetItem['Duration'] > 0) $Output .= '<td>'.$PrefixMultiplier->Add($MeetItem['Length'] / $MeetItem['Duration'] * 3600, '', 4, 'Decimal').'</td>';
        else $Output .= '<td>&nbsp;</td>';
      $Output .= '</tr>';
    }
    $Output .= '</table>';
    $Output .= $PageList['Output'];
    $Output .= '</div><br/>';

    // Show daily stats
    $Where = '1';

    $DailyTableMaxId = 'SELECT * FROM (SELECT MAX(Id) AS MaxId FROM `RunnerStat` AS T1 WHERE T1.Runner='.$RunnerId.' GROUP BY DATE(Time)) AS T2 LEFT JOIN RunnerStat AS T3 ON T3.Id=T2.MaxId';
    $DailyTableMinId = 'SELECT * FROM (SELECT MIN(Id) AS MinId FROM `RunnerStat` AS T1 WHERE T1.Runner='.$RunnerId.' GROUP BY DATE(Time)) AS T2 LEFT JOIN RunnerStat AS T3 ON T3.Id=T2.MinId';
    $DbResult = $this->Database->query('SELECT COUNT(*) FROM ('.$DailyTableMaxId.') AS B');
    $DbRow = $DbResult->fetch_row();
    $PageList = GetPageList($DbRow[0]);

    $Output .= '<div style="text-align: center">Daily</div>';
    $Output .= '<div id="list_content">';
    $Output .= $PageList['Output'];
    $TableColumns = array(
      array('Name' => 'Time', 'Title' => 'Time'),
      array('Name' => 'Distance', 'Title' => 'Distance [km]'),
      array('Name' => 'Money', 'Title' => 'Money [Kč]'),
      array('Name' => 'Rank', 'Title' => 'Rank'),
      array('Name' => 'Duration', 'Title' => 'Duration'),
      array('Name' => 'Length', 'Title' => 'Length [km]'),
      array('Name' => 'Speed', 'Title' => 'Speed [km/hour]'),
    );
    $Order = GetOrderTableHeader($TableColumns, 'Time', 1);
    $Output .= '<table class="WideTable">';
    $Output .= $Order['Output'];
    $DbResult = $this->Database->query('SELECT * '.
      ', (SELECT T4.Distance - B.Distance + 1.5 FROM ('.$DailyTableMinId.') AS B WHERE (DATE(B.Time) = DATE(T4.Time)) AND (B.Runner = T4.Runner) ORDER BY B.Time DESC LIMIT 1) AS Length'.
      ', (SELECT TIME_TO_SEC(TIMEDIFF(T4.Time, B.Time)) / (Length - 1.5) * Length FROM ('.$DailyTableMinId.') AS B WHERE (DATE(B.Time) = DATE(T4.Time)) AND (B.Runner = T4.Runner) ORDER BY B.Time DESC LIMIT 1) AS Duration'.
      ', NULL AS Speed'.
      ' FROM ('.$DailyTableMaxId.') AS T4'.
      ' WHERE '.$Where.$Order['SQL'].$PageList['SQLLimit']);
    while($MeetItem = $DbResult->fetch_assoc())
    {
      $Output .= '<tr>'.
        '<td>'.HumanDateTime(MysqlDateTimeToTime($MeetItem['Time'])).'</td>'.
        '<td>'.$MeetItem['Distance'].'</td>'.
        '<td>'.$MeetItem['Money'].'</td>'.
        '<td>'.$MeetItem['Rank'].'</td>';
      if ($MeetItem['Duration'] != null) $Output .= '<td>'.$PrefixMultiplier->Add($MeetItem['Duration'], '', 4, 'Time').'</td>';
        else $Output .= '<td>&nbsp;</td>';
      $Output .= '<td>'.$MeetItem['Length'].'</td>';
      if ($MeetItem['Duration'] > 0) $Output .= '<td>'.$PrefixMultiplier->Add($MeetItem['Length'] / $MeetItem['Duration'] * 3600, '', 4, 'Decimal').'</td>';
        else $Output .= '<td>&nbsp;</td>';
      $Output .= '</tr>';
    }
    $Output .= '</table>';
    $Output .= $PageList['Output'];
    $Output .= '</div>';

    return($Output);
  }

  function ShowPage($Content)
  {
    global $Config;

    $Output = '<?xml version="1.0" encoding="'.$this->Config['Encoding'].'"?>'."\n".
      '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'.
      '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="cs" lang="cs">'.
      '<head>'.
      '<link rel="stylesheet" href="'.$this->Link('/style.css').'" type="text/css" media="all" />'.
      '<meta http-equiv="content-type" content="application/xhtml+xml; charset='.$this->Config['Encoding'].'" />'.
      '<script src="'.$this->Link('/jquery.js').'"></script>';
    $Output .= '<title>Teribear stats</title>'.
      '</head><body>';
    $Output .= $Content;
    $Output .= '<br/><div class="footer">Contact: <a href="mailto:'.$Config['Contact'].'">'.$Config['Contact'].'</a> '.
       '<a href="https://app.zdechov.net/teribear/">Source code</a></div>';
    $Output .= '</body></html>';
    return($Output);
  }

  function Run()
  {
    global $Config;

    $this->Config = $Config;
    $this->Database = new Database();
    $this->Database->Connect($this->Config['Database']['Host'], $this->Config['Database']['User'],
      $this->Config['Database']['Password'], $this->Config['Database']['Database']);
    $this->Database->Prefix = $this->Config['Database']['Prefix'];
    $this->Database->charset($this->Config['Database']['Charset']);
    $this->PathItems = $this->ProcessURL();

    $Output = '';

    if(count($this->PathItems) > 0)
    {
      if($this->PathItems[0] == 'sync') $Output .= $this->ShowSync();
      //else if($this->PathItems[0] == 'empty') $Output .= $this->ShowEmpty();
      else if($this->PathItems[0] == 'runner') $Output .= $this->ShowRunner();
      else if($this->PathItems[0] == 'team') $Output .= $this->ShowTeam();
      else $Output .= $this->ShowTeams();
    } else $Output .= $this->ShowTeams();
    if (!$this->NoFullPage)
    {
      $Output = $this->ShowMenu().$Output;
      echo($this->ShowPage($Output));
    } else echo($Output);
  }
}

$Application = new MyApplication();
$Application->Run();
